package com.emoon.knowledge.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.PromptTemplate;
import com.emoon.knowledge.domain.bo.PromptTemplateBo;
import com.emoon.knowledge.domain.vo.PromptTemplateVo;
import com.emoon.knowledge.mapper.PromptTemplateMapper;
import com.emoon.knowledge.service.IPromptTemplateService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 提示词模板（生产级）Service业务层处理
 *
 * @author wangkang
 * @date 2026-01-25
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class PromptTemplateServiceImpl implements IPromptTemplateService {

    private final PromptTemplateMapper baseMapper;

    /**
     * 查询提示词模板（生产级）
     *
     * @param id 主键
     * @return 提示词模板（生产级）
     */
    @Override
    public PromptTemplateVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询提示词模板（生产级）列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 提示词模板（生产级）分页列表
     */
    @Override
    public TableDataInfo<PromptTemplateVo> queryPageList(PromptTemplateBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PromptTemplate> lqw = buildQueryWrapper(bo);
        Page<PromptTemplateVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的提示词模板（生产级）列表
     *
     * @param bo 查询条件
     * @return 提示词模板（生产级）列表
     */
    @Override
    public List<PromptTemplateVo> queryList(PromptTemplateBo bo) {
        LambdaQueryWrapper<PromptTemplate> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PromptTemplate> buildQueryWrapper(PromptTemplateBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PromptTemplate> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(PromptTemplate::getId);
        lqw.eq(bo.getProjectId() != null, PromptTemplate::getProjectId, bo.getProjectId());
        lqw.like(StringUtils.isNotBlank(bo.getPromptName()), PromptTemplate::getPromptName, bo.getPromptName());
        lqw.eq(StringUtils.isNotBlank(bo.getPromptContent()), PromptTemplate::getPromptContent, bo.getPromptContent());
        lqw.eq(StringUtils.isNotBlank(bo.getPromptDesc()), PromptTemplate::getPromptDesc, bo.getPromptDesc());
        lqw.eq(StringUtils.isNotBlank(bo.getPromptType()), PromptTemplate::getPromptType, bo.getPromptType());
        lqw.eq(bo.getStatus() != null, PromptTemplate::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增提示词模板（生产级）
     *
     * @param bo 提示词模板（生产级）
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(PromptTemplateBo bo) {
        PromptTemplate add = MapstructUtils.convert(bo, PromptTemplate.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改提示词模板（生产级）
     *
     * @param bo 提示词模板（生产级）
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(PromptTemplateBo bo) {
        PromptTemplate update = MapstructUtils.convert(bo, PromptTemplate.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PromptTemplate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除提示词模板（生产级）信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
